## MvvmCross

MvvmCross is a cross-platform mvvm framework that enables developers to create cross platform apps. Additional support is available for [Xamarin.Forms](https://github.com/MvvmCross/MvvmCross-Forms) and the [Android support library](https://github.com/MvvmCross/MvvmCross-AndroidSupport). Lots of [plugins](https://github.com/MvvmCross/MvvmCross-Plugins) are available as well.

## Documentation & blog

* See our [official website](http://www.mvvmcross.com/docs) for an extensive set of documentation!
* To stay up-to-date with the latest news go to the [MvvmCross blog](http://www.mvvmcross.com/blog)!

### Get started

A quick way to get started is to use the Visual Studio MvvmCross [Ninja Coder](https://github.com/asudbury/NinjaCoderForMvvmCross) Extension - download it from [Visual Studio Gallery](https://visualstudiogallery.msdn.microsoft.com/618b51f0-6de8-4f85-95ce-a50c658c7767)

For manual project creation install the necessary packages from [Nuget](https://www.nuget.org/packages?q=mvvmcross)


### Questions & support

* [StackOverflow](http://stackoverflow.com/questions/tagged/mvvmcross)
* [Xamarin forums](http://forums.xamarin.com)
* [Slack](https://xamarinchat.herokuapp.com/) join the mvvmcross channel after you are in


### Documentation and Examples

**The [MvvmCross-Samples](https://github.com/MvvmCross/MvvmCross-Samples) repo contains the latest samples. See the [MvvmCross Wiki](https://github.com/MvvmCross/MvvmCross/wiki) for additional articles and information.**

**Samples and Videos:**

* **[N Plus 1 Videos Of MvvmCross][n1videos]**
* [MvvmCross Tutorials][mvxtuts]
* [Evolve 2013 talk](http://xamarin.com/evolve/2013#session-dnoeeoarfj)
* [NDC 2013 talk](http://slodge.blogspot.co.uk/2013/06/ndc2013-mobile-mvvm-and-xamarin-talks.html)
* [Xaminar - 2012](http://slodge.blogspot.com/2012/12/mvvmcross-video-presentation-xaminar.html)
* [MvvmCross and Azure - 2012](http://slodge.blogspot.co.uk/2012/11/azure-to-wpmonodroidmonotouch-video-of.html)


**The Tip Calc tutorial:**

* [A first app](https://github.com/MvvmCross/MvvmCross/wiki/Tip-Calc-A-first-app)
* [The Core Project](https://github.com/MvvmCross/MvvmCross/wiki/Tip-Calc---The-Core-Project)
* [A Xamarin.Android UI project](https://github.com/MvvmCross/MvvmCross/wiki/Tip-Calc-A-Xamarin.Android-UI-project)
* [A Xamarin.iOS UI project](https://github.com/MvvmCross/MvvmCross/wiki/Tip-Calc-A-Xamarin.iOS-UI-project)
* [A Universal Windows App UI Project](https://github.com/MvvmCross/MvvmCross/wiki/Tip-Calc-A-Universal-Windows-App-UI-Project)
* [A Windows Phone UI Project](https://github.com/MvvmCross/MvvmCross/wiki/Tip-Calc-A-Windows-Phone-UI-Project)
* [A Windows Store UI Project](https://github.com/MvvmCross/MvvmCross/wiki/Tip-Calc-Windows-Store-Project)
* [A Wpf UI Project](https://github.com/MvvmCross/MvvmCross/wiki/Tip-Calculator-A-Wpf-UI-Project)
* [Tip Calculator -  A recap](https://github.com/MvvmCross/MvvmCross/wiki/Tip-Calculator---A-recap)

**General articles:**

* [The MvvmCross Manifesto](https://github.com/MvvmCross/MvvmCross/wiki/The-MvvmCross-Manifesto)
* [High Level MvvmCross Objects](https://github.com/MvvmCross/MvvmCross/wiki/High-Level-MvvmCross-Objects)
* [Databinding](https://github.com/MvvmCross/MvvmCross/wiki/Databinding)
* [Value Converters](https://github.com/MvvmCross/MvvmCross/wiki/Value-Converters)
* [View Model Lifecycle](https://github.com/MvvmCross/MvvmCross/wiki/View-Model-Lifecycle)
* [ViewModel  to ViewModel navigation](https://github.com/MvvmCross/MvvmCross/wiki/ViewModel--to-ViewModel-navigation)
* [Customising App and Setup ](https://github.com/MvvmCross/MvvmCross/wiki/Customising-using-App-and-Setup)
* [Service Location and Inversion of Control](https://github.com/MvvmCross/MvvmCross/wiki/Service-Location-and-Inversion-of-Control)
* [Assemblies](https://github.com/MvvmCross/MvvmCross/wiki/MvvmCross-Assemblies)
* [Plugins](https://github.com/MvvmCross/MvvmCross/wiki/MvvmCross-plugins)
* [Testing](https://github.com/MvvmCross/MvvmCross/wiki/Testing)
* [Dialog - very draft](https://github.com/MvvmCross/MvvmCross/wiki/CrossUI---MonoTouch.Dialog-and-MonoDroid.Dialog-with-MvvmCross)

**iOS Articles:**

* [Tables and Cells in iOS](https://github.com/MvvmCross/MvvmCross/wiki/Tables-and-Cells-in-iOS)
* [Map Annotation Data-Binding](https://github.com/MvvmCross/MvvmCross/wiki/Map-Annotation-Data-Binding)

**For more information please also see:**

* the N+1 video series - [N Plus 1 Videos Of MvvmCross][n1videos]
* [Stuart's blog][slogdeblog]
* [Cheesebaron's blog][cheesebaron]
* [DeapSquatter's blog][deapsquatter]
* [Odenaxos's blog][odenaxos]
* [Greg's blog][gshackles] 
* [Kerry's blog][lothrop]
* [Jammer's blog](http://www.jammer.biz/category/geek-bits/)
* others? Get in touch if you think your blog should be here......


### Contribute!

Some of the best ways to contribute are to try things out, file bugs, and join conversations.

* [Pull requests](https://github.com/MvvmCross/MvvmCross/pulls): [Open](https://github.com/MvvmCross/MvvmCross/pulls?q=is%3Aopen+is%3Apr)/[Closed](https://github.com/MvvmCross/MvvmCross/pulls?q=is%3Apr+is%3Aclosed)
* [Issues](https://github.com/MvvmCross/MvvmCross/issues): [Open](https://github.com/MvvmCross/MvvmCross/issues?q=is%3Aopen+is%3Aissue)/[Closed](https://github.com/MvvmCross/MvvmCross/issues?q=is%3Aissue+is%3Aclosed)

If you would like to help make MvvmCross even better, then please do:

* new code - including pull requests via GitHub - or you can fork the project and build your own extensions
* new plugins - can be hosted in your own repositories
* please do blog about your adventures with MvvmCross - we're currently light on documentation!
* if you use the framework, then please let me know - we love to see what people are doing with it


### Licensing

MvvmCross is licensed under the [MS-PL License](http://opensource.org/licenses/ms-pl.html)

* [MonoCross](http://code.google.com/p/monocross/) was the original starting point for this project, and was used as a reference under MIT
* [Phone7.Fx](http://phone7.codeplex.com) is redistributed and modified under MS-PL
* Tiny bits of [MvvmLight](http://mvvmlight.codeplex.com/) are redistributed and modified under MIT
* [NewtonSoft.Json](https://github.com/JamesNK/Newtonsoft.Json) is redistributed and modified here under MIT
* The original work on the [JSON.Net port](https://github.com/chrisntr/Newtonsoft.Json) to MonoTouch and MonoDroid was done by @ChrisNTR
* [Sqlite-net](https://github.com/praeclarum/sqlite-net/blob/master/license.md) - custom license
* [MonoTouch.Dialog](https://github.com/migueldeicaza/MonoTouch.Dialog) - MIT X11 
* [MonoDroid.Dialog](https://github.com/kevinmcmahon/MonoDroid.Dialog) - MIT X11
* Messenger ideas from [JonathanPeppers/XPlatUtils](https://github.com/jonathanpeppers/XPlatUtils) under Apache License Version 2.0, and from GrumpyDev/TinyMessenger under simple license of "THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY"
* [Color codes](https://github.com/mono/sysdrawing-coregraphics) under MIT License


### Acknowledgements

* Thanks to [McCannLondon](http://blogs.mccannlondon.co.uk/) for sponsoring the initial part of this work
* Thanks to [JetBrains](http://jetbrains.com) for a community Resharper license to use on this project
* Thanks to [Infragistics](http://www.infragistics.com/) for a control license for Nuclios and .Net


[ninja]: http://i.imgur.com/eJ3ewEq.png "Ninja Plugin"
[ninjavsgallery]: http://visualstudiogallery.msdn.microsoft.com/618b51f0-6de8-4f85-95ce-a50c658c7767 "Ninja Coder Visual Studio Gallery"
[n1]: http://mvvmcross.wordpress.com "MvvmCross N+1 table of contents"
[n1github]: https://github.com/MvvmCross/NPlus1DaysOfMvvmCross "MvvmCross N+1 on GitHub"
[n1videos]: https://github.com/MvvmCross/MvvmCross/wiki/N-1-Videos-Of-MvvmCross
[mvxtuts]: https://github.com/MvvmCross/MvvmCross-Tutorials/ "MvvmCross Tutorials"
[mvxwiki]: https://github.com/MvvmCross/MvvmCross/wiki "MvvmCross Wiki"
[mvxnuget]: https://www.nuget.org/packages?q=mvvmcross "MvvmCross on NuGet"
[mvxbin]: https://github.com/mvvmcross/MvvmCross-Binaries/ "MvvmCross Binaries"
[cirrious]: http://www.cirrious.com
[slogdeblog]: http://slodge.blogspot.co.uk/ "Stuart Lodge's blog"
[jabbr]: http://jabbr.net/#/rooms/mvvmcross "MvvmCross on Jabbr.net"
[cheesebaron]: http://blog.ostebaronen.dk/search/label/MvvmCross "Cheesebaron's blog"
[deapsquatter]: http://deapsquatter.blogspot.co.uk/ "DeapSquatter's blog"
[odenaxos]: http://www.e-naxos.com/Blog/?tag=/mvvmcross "Odenaxos's blog"
[gshackles]: http://www.gregshackles.com/tag/mvvmcross/ "Greg Shackle's blog"
[so]: http://stackoverflow.com/questions/tagged/mvvmcross "MvvmCross on StackOverflow"
[xfmvx]: http://forums.xamarin.com/search?Search=mvvmcross "MvvmCross on Xamarin Forums"
[xf]: http://forums.xamarin.com "Xamarin Forums"
[mvxtwitter]: https://twitter.com/MvvmCross "MvvmCross on Twitter"
[mvxmail]: http://slodge.blogspot.co.uk/2013/06/my-standard-reply-to-mvvmcross-support.html "MvvmCross e-mail"
[mvxv3]: http://slodge.blogspot.co.uk/2013/02/mvvmcross-v3.html "MvvmCross v3"
[lothrop]: http://kerry.lothrop.de/tag/mvvmcross/ "Kerry Lothrop's blog"
